// Compile on bcc55
// winmm.lib N
/*#pragma comment(lib,"winmm")*/
#include <windows.h>
#include <commctrl.h>
#define BTN_ID0		200
#define BTN_ID1		201
#define BTN_ID2		202
#define BTN_ID3		203

LRESULT CALLBACK WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
VOID CALLBACK OutDispProc(HWND hWnd , UINT uMsg ,UINT idEvent , DWORD dwTime);
void Initialize( HWND hWnd );
void PutButton( HWND hParentWnd, int no, int left, int top, int width, int height, char *cap );
void ClrButton( int EntryNum );
HWND CreateToolTip( HWND hparent );
void AddToolTip( HWND hToopTip, HWND hCtrl, char *text );
void SetToolTip( HWND hWnd );
void GetFileNameList( HWND hWnd, char *filename );
void CreateMeter( HWND hWnd );
void ClrMeter( void );
void openMidi( int No );
void playMidi( HWND hWnd );
void pauseMidi( void );
void closeMidi( void );
void resumeMidi( void );
HINSTANCE hInst;
int FrameSizeHeight, FrameSizeWidth, FrameSizeCaption;
HWND hButton[4];
HWND hToolTip;
char ToolTipText[256];
OPENFILENAME ofn;
char setupinipath[255];
char GetFilename[8192];
char DirectoryName[1024];
char FileList[256][256];
int FileListNum = 0;
int PlayListNum = 0;
BOOL midiPause = FALSE;
BOOL midiRepeat = FALSE;
BOOL meterOn = FALSE;
HDC MeterHdc, WkHdc;
int sndLength = 0;
long LoopCnt = 0;
char repeatMark[4] = "\0";
char meterMark[4] = "\0";
char openMidiFile[1024];
char playMidiFile[17] = "play midi notify";
char pauseMidiFile[11] = "pause midi";
char resumeMidiFile[12] = "resume midi";
char closeMidiFile[11] = "close midi";
char setMilliMidiFile[34] = "set midi time format milliseconds";
char lenMidiFile[19] = "status midi length";
char posMidiFile[21] = "status midi position";

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					 LPSTR lpszArgs, int nWinMode ){
	HWND hwnd;
	MSG msg;
	WNDCLASS wc;
	RECT rcRect;
	char value[2];

	wc.hInstance = hInstance;
	wc.lpszClassName = "midi";
	wc.lpfnWndProc = ( WNDPROC )WindowProc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hIcon = LoadIcon( hInstance, NULL );
	wc.hCursor = LoadCursor(( HINSTANCE )NULL, IDC_ARROW );
	wc.lpszMenuName = NULL;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );

	if ( !RegisterClass( &wc )) return FALSE;
	hwnd = CreateWindow(
		"midi",
		"",
		WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU, CW_USEDEFAULT, CW_USEDEFAULT,
		240,
		15,
		( HWND )NULL, (HMENU)NULL, hInstance, ( LPVOID )NULL );
	if ( !hwnd ) return FALSE;
	hInst = GetModuleHandle( NULL );
	FrameSizeHeight = GetSystemMetrics( SM_CYFIXEDFRAME );
	FrameSizeCaption = GetSystemMetrics( SM_CYCAPTION );
	FrameSizeWidth = GetSystemMetrics( SM_CXFIXEDFRAME );
	GetWindowRect( hwnd, &rcRect );
	SetWindowPos( hwnd, NULL, rcRect.left, rcRect.top, 240+FrameSizeWidth*2, 15+FrameSizeHeight*2+FrameSizeCaption, NULL );
	Initialize( hwnd );
	ShowWindow( hwnd, nWinMode );
	UpdateWindow( hwnd );
	CreateMeter( hwnd );
	SetTimer( hwnd, 1, 50, OutDispProc );
	while(1){
		if ( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ){
			if ( !GetMessage( &msg, ( HWND )NULL, 0, 0 ) ) { break; };
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		LoopCnt++;
		if ( LoopCnt >= 10000 ){
			Sleep( 100 );
			LoopCnt = 0;
		}
	}
	ClrMeter();
	KillTimer( hwnd , 1 );
	WritePrivateProfileString( "Setting", "Meter", itoa( meterOn, value, 10 ), setupinipath );
	return msg.wParam;
}

LRESULT CALLBACK WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch(uMsg){
		case WM_CREATE:
			PutButton( hWnd, 1, 180, 0, 20, 15, "|>" );
			PutButton( hWnd, 2, 200, 0, 20, 15, "<" );
			PutButton( hWnd, 3, 220, 0, 20, 15, ">" );
			break;
		case WM_PAINT:
			break;
		case WM_COMMAND:    // {^ꂽ
			switch( LOWORD(wParam) ) {
				case BTN_ID1:		// {^P
					if ( FileListNum != 0 ){
						if ( PlayListNum <= FileListNum ){
							if ( midiPause == FALSE ){
								midiPause = TRUE;
								SetWindowText( hButton[1], "|>" );
								pauseMidi();
							}
							else{
								midiPause = FALSE;
								SetWindowText( hButton[1], "||" );
								playMidi( hWnd );
							}
							SetFocus( hWnd );
						}
						else{
							closeMidi();
							SetFocus( hWnd );
							PlayListNum = 1;
							SetWindowText( hWnd, FileList[PlayListNum-1] );
							SetWindowText( hButton[1], "||" );
							openMidi( PlayListNum );
							playMidi( hWnd );
						}
						SetToolTip( hWnd );
					}
					else
						SetFocus( hWnd );
					break;
				case BTN_ID2:		// {^Q
					if ( FileListNum != 0 ){
						SetWindowText( hButton[1], "|>" );
						midiPause = FALSE;
						if ( PlayListNum == 1 )
							PlayListNum = FileListNum;
						else
							PlayListNum--;
						closeMidi();
						SetFocus( hWnd );
						SetWindowText( hWnd, FileList[PlayListNum-1] );
						SetWindowText( hButton[1], "||" );
						openMidi( PlayListNum );
						playMidi( hWnd );
						SetToolTip( hWnd );
					}
					else
						SetFocus( hWnd );
					break;
				case BTN_ID3:		// {^R
					if ( FileListNum != 0 ){
						SetWindowText( hButton[1], "|>" );
						midiPause = FALSE;
						if ( PlayListNum >= FileListNum )
							PlayListNum = 1;
						else
							PlayListNum++;
						closeMidi();
						SetFocus( hWnd );
						SetWindowText( hWnd, FileList[PlayListNum-1] );
						SetWindowText( hButton[1], "||" );
						openMidi( PlayListNum );
						playMidi( hWnd );
						SetToolTip( hWnd );
					}
					else
						SetFocus( hWnd );
					break;
				default:
					return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
			}
			break;
		case WM_RBUTTONDOWN:
			ofn.lpstrFile[0] = '\0';
			if ( GetOpenFileName( &ofn ) )
			{
				GetFileNameList( hWnd, ofn.lpstrFile );
				SetWindowText( hWnd, FileList[0] );
				midiPause = FALSE;
				PlayListNum = 1;
				SetToolTip( hWnd );
				closeMidi();
				SetWindowText( hButton[1], "||" );
				openMidi( 1 );
				playMidi( hWnd );
			}
			break;
		case WM_KEYDOWN:
			switch( wParam ){
			case 0x4f:		// O Key
				PostMessage( hWnd, WM_RBUTTONDOWN, 0, 0 );
				break;
			case 0x52:		// R Key
				if ( midiRepeat == FALSE ){
					midiRepeat = TRUE;
					strcpy( repeatMark, "(r)" );
				}
				else{
					midiRepeat = FALSE;
					strcpy( repeatMark, "\0" );
				}
				break;
			case 0x4d:		// M key
				if ( meterOn == FALSE ){
					meterOn = TRUE;
					strcpy( meterMark, "m" );
				}
				else{
					meterOn = FALSE;
					strcpy( meterMark, "\0" );
				}
				break;
			}
			break;
		case MM_MCINOTIFY:
			if ( wParam != MCI_NOTIFY_SUCCESSFUL )
				break;
			if ( midiRepeat == TRUE ){
				SetWindowText( hButton[1], "|>" );
				if ( PlayListNum == FileListNum ){
					closeMidi();
					PlayListNum = 1;
					SetWindowText( hWnd, FileList[PlayListNum-1] );
					SetWindowText( hButton[1], "||" );
					openMidi( 1 );
					playMidi( hWnd );
				}
				else{
					PlayListNum++;
					closeMidi();
					SetWindowText( hWnd, FileList[PlayListNum-1] );
					SetWindowText( hButton[1], "||" );
					openMidi( PlayListNum );
					playMidi( hWnd );
				}
			}
			else{
				if ( PlayListNum != FileListNum ){
					SetWindowText( hButton[1], "|>" );
					PlayListNum++;
					closeMidi();
					SetWindowText( hWnd, FileList[PlayListNum-1] );
					SetWindowText( hButton[1], "||" );
					openMidi( PlayListNum );
					playMidi( hWnd );
				}
				else{
					SetWindowText( hWnd, "" );
					SetWindowText( hButton[1], "|>" );
					PlayListNum++;
					sndLength = 0;
				}
			}
			SetToolTip( hWnd );
			break;
		case WM_DESTROY:
			ClrButton( 3 );
			closeMidi();
			PostQuitMessage(0);
			return 0;
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void Initialize( HWND hWnd )
{
	char value[255];

	ofn.lStructSize = sizeof( OPENFILENAME );
	ofn.hwndOwner = hWnd;
	ofn.nFilterIndex = 1;
	ofn.nMaxFile = 8192;
	ofn.lpstrTitle = "midit@CJ";
	DirectoryName[0] = '\0';
	GetFilename[0] = '\0';
	ofn.lpstrInitialDir = DirectoryName;
	ofn.lpstrFile = GetFilename;
	ofn.lpstrFilter = "midi file(*.mid;*.midi)\0*.mid;*.midi\0All files(*.*)\0*.*\0\0";
	ofn.Flags = 0x2080205;
	CreateToolTip( hWnd );
	strcpy( ToolTipText, "" );
	AddToolTip( hToolTip, hButton[1], ToolTipText );
	AddToolTip( hToolTip, hButton[2], ToolTipText );
	AddToolTip( hToolTip, hButton[3], ToolTipText );
	GetCurrentDirectory( 255, setupinipath );
	strcat( setupinipath, "\\setup.ini" );
	GetPrivateProfileString( "Setting", "Meter", "0", value, 255, setupinipath );
	if ( atoi(value) ){
		meterOn = FALSE;
		PostMessage( hWnd, WM_KEYDOWN, 0x4d, 0 );
	}
}

void PutButton( HWND hParentWnd, int no, int left, int top, int width, int height, char *cap )
{
	hButton[no] = CreateWindow(
					"button",								// NX
					cap,									// Window ̃^Cg
					WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,	// Window ̃X^C
					left,									// Window ̐W
					top,									// Window ̐W
					width,									// Window ̕
					height,									// Window ̍
					hParentWnd,								// eWindow ̃nh
					(HMENU)(BTN_ID0 + no),					// Window hc
					hInst,									// CX^Xnh
					NULL);
}

void ClrButton( int EntryNum )
{
	int i;

	for(i=1;i<=EntryNum;i++)
		DestroyWindow( hButton[i] );
}

void GetFileNameList( HWND hWnd, char *filename )
{
	int i, j;

	FileListNum = 0;
	j = ofn.nFileOffset - 1;
	if ( ofn.lpstrFile[j] == '\0' )
		j--;
	for(i=0;i<=j;i++)
		DirectoryName[i] = ofn.lpstrFile[i];
	if ( ofn.lpstrFile[j] != '\\' )
		DirectoryName[i++] = '\\';
	DirectoryName[i] = '\0';
	i = ofn.nFileOffset;
	j = 0;
	while( (filename[i] != '\0') || (filename[i+1] != '\0') )
	{
		if ( filename[i] != '\0' )
			FileList[FileListNum][j++] = filename[i++];
		else{
			FileList[FileListNum][j] = '\0';
			j = 0;
			i++;
			FileListNum++;
		}
	}
	FileList[FileListNum][j] = '\0';
	FileListNum++;
}

HWND CreateToolTip( HWND hparent )
{
	hToolTip = CreateWindowEx( WS_EX_TOPMOST,
								TOOLTIPS_CLASS,
								NULL,
								WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,
								0,0,0,0,
								hparent,
								0,
								hInst,
								NULL );
	return hToolTip;
}

void AddToolTip( HWND hToolTip, HWND hCtrl, char *text )
{
	TOOLINFO ti;

	ZeroMemory( &ti, sizeof( TOOLINFO ) );
	ti.cbSize = sizeof( TOOLINFO );
	ti.hwnd = hCtrl;
	ti.uFlags = TTF_SUBCLASS | TTF_IDISHWND;
	ti.uId = (UINT)hCtrl;
	ti.lpszText = text;
	SendMessage( hToolTip, TTM_ADDTOOL, 0, LPARAM(&ti) );
}

void SetToolTip( HWND hWnd )
{
	strcpy( ToolTipText, "" );
	if ( PlayListNum <= FileListNum ){
		strcat( ToolTipText, "" );
		strcat( ToolTipText, FileList[PlayListNum-1] );
		if ( ToolTipText[strlen(ToolTipText)-4] == '.' )
			ToolTipText[strlen(ToolTipText)-4] = 0;
		AddToolTip( hToolTip, hButton[1], ToolTipText );
	}
	else
		AddToolTip( hToolTip, hButton[1], ToolTipText );
	strcpy( ToolTipText, "" );
	if ( PlayListNum != 1 ){
		strcat( ToolTipText, FileList[PlayListNum-2] );
		if ( ToolTipText[strlen(ToolTipText)-4] == '.' )
			ToolTipText[strlen(ToolTipText)-4] = 0;
		AddToolTip( hToolTip, hButton[2], ToolTipText );
	}
	else
		AddToolTip( hToolTip, hButton[2], ToolTipText );
	strcpy( ToolTipText, "" );
	if ( PlayListNum+1 <= FileListNum ){
		strcat( ToolTipText, FileList[PlayListNum] );
		if ( ToolTipText[strlen(ToolTipText)-4] == '.' )
			ToolTipText[strlen(ToolTipText)-4] = 0;
		AddToolTip( hToolTip, hButton[3], ToolTipText );
	}
	else
		AddToolTip( hToolTip, hButton[3], ToolTipText );
}

void CreateMeter( HWND hWnd )
{
	HDC hdc;
	HBRUSH hBrushGreen, hOldBrush;
	HPEN hPenGreen, hOldPen;
	HBITMAP hBackBmp, hBackBmp2;
	int i, j;

	hdc = GetDC( hWnd );
	MeterHdc = CreateCompatibleDC( hdc );
	WkHdc = CreateCompatibleDC( hdc );
	hBackBmp = CreateCompatibleBitmap( hdc, 180, 15 );
	hBackBmp2 = CreateCompatibleBitmap( hdc, 180, 15 );
	SelectObject( MeterHdc, hBackBmp );
	SelectObject( WkHdc, hBackBmp2 );
	hBrushGreen = CreateSolidBrush( RGB(0, 255, 0) );
	hPenGreen = CreatePen( PS_SOLID, 0, RGB(0, 240, 0) );
	hOldBrush = (HBRUSH)SelectObject( MeterHdc, hBrushGreen );
	hOldPen = (HPEN)SelectObject( MeterHdc, hPenGreen );
	PatBlt( MeterHdc, 0, 0, 180, 15, WHITENESS );
	j = 0;
	for(i=0;i<20;i++){
		Rectangle( MeterHdc, j, 0, j+8, 15 );
		j = j + 9;
	}
	SelectObject( MeterHdc, hOldBrush );
	SelectObject( MeterHdc, hOldPen );
	DeleteObject( hBrushGreen );
	DeleteObject( hPenGreen );
	DeleteObject( hBackBmp );
	DeleteObject( hBackBmp2 );
	ReleaseDC( hWnd, hdc );
}

void ClrMeter( void )
{
	DeleteObject( MeterHdc );
	DeleteObject( WkHdc );
}

VOID CALLBACK OutDispProc(HWND hWnd , UINT uMsg ,UINT idEvent , DWORD dwTime)
{
	HDC hdc;
	RECT rect;
	PAINTSTRUCT ps;
	char str[64];
	int getpos, timelen;

	rect.left = 0;
	rect.top = 0;
	rect.right = 180;
	rect.bottom = 15;
	InvalidateRect( hWnd, &rect, FALSE );
	hdc = BeginPaint( hWnd, &ps );
	mciSendString( posMidiFile, str, sizeof(str), NULL );
	getpos = atoi(str) / 1000;
	if ( sndLength != 0 )
		timelen = (int)((float)(getpos + 1) / sndLength * 100 / 2);
	else
		timelen = 0;
	PatBlt( WkHdc, 0, 0, 180, 15, WHITENESS );
	if ( meterOn == TRUE )
		BitBlt( WkHdc, 0, 0, (int)(3.6*timelen), 15, MeterHdc, 0, 0, SRCCOPY );
	SetBkMode( WkHdc, TRANSPARENT );
	wsprintf( str,"(C) MiniM  ver0.22%s%s", repeatMark, meterMark );
	TextOut( WkHdc, 0, 0, str, lstrlen(str) );
	BitBlt( hdc, 0, 0, 180, 15, WkHdc, 0, 0, SRCCOPY );
	EndPaint( hWnd, &ps );
}

void openMidi( int No )
{
	char str[64];

	if ( (No == 0) || (No > FileListNum) )
		return;
	strcpy( openMidiFile, "open \"" );
	strcat( openMidiFile, DirectoryName );
	strcat( openMidiFile, FileList[No-1] );
	strcat( openMidiFile, "\" alias midi");
	mciSendString( openMidiFile, NULL, 0, NULL );
	mciSendString( setMilliMidiFile, NULL, 0, NULL );
	mciSendString( lenMidiFile, str, sizeof(str), NULL );
	sndLength = atoi(str) / 1000;
}

void playMidi( HWND hWnd )
{
	mciSendString( playMidiFile, NULL, 0, hWnd );
}

void pauseMidi( void )
{
	mciSendString( pauseMidiFile, NULL, 0, NULL );
}

void resumeMidi( void )
{
	mciSendString( resumeMidiFile, NULL, 0, NULL );
}

void closeMidi( void )
{
	mciSendString( closeMidiFile, NULL, 0, NULL );
}
